##           BLENDERWORLD V0.2
##                      Sript de modlisation de terrains

##--LANCEMENT--#########################################
########################################################
##     ###      ##     ########         #####         ##
##    ## ##     ##        ##            ## ##         ##
##   ##   ##    ##        ##    #####   ####          ##
##  #########   ##        ##    #####   ##            ##
## ##       ##  #####     ##            ##            ##
########################################################
########################################################

## Installation: #######################################
########################################################
# Normalement il n'y en a pas mais si rien ne ce passe #
# apres avoir fait Alt-P, et qu'il est inscrit dans la #
# fenetre MS-Dos qu'il y a un probleme de coordonnees  #
# referencez-vous a la rubrique 'Probleme possible'.   #
########################################################

## ET HAPPY BLENDING A TOUT LE MONDE ###################
########################################################

## Probleme possible: ##################################
########################################################
# Si vous n'avez pas installe la version du python     #
# complete sur votre ordinateur vous devez indiquez ou #
# vous s'avez installe ce script:                      #
########################################################

# Sous Windows
dir='e:\\blender\\python\\blenderworld\\'
# Sous Linus
#dir='/blender/python/blenderworld/'
##--declarations--######################################
########################################################
import Blender
from Blender import NMesh
from Blender.Draw import *
from Blender.BGL import *
import time


try:
    import os, sys
    import Blender210
    bnom=Blender210.getFilename()
    if sys.platform== "win32":
        dir=os.path.dirname(bnom)+'\\'
    else:
        dir=os.path.dirname(bnom)+'/'
    loctest=dir+'noz.tga'
    f=open(loctest,'rb')
    f.close()
except:
    loctest=dir+'noz.tga'
    try:
        f=open(loctest,'rb')
        f.close()
    except:
        print 'Vous n"avez pas correctement entrez les coordonnees du script'
    

##--traitement des images--#############################
########################################################
## Remerciement a JM car le script pour afficher les  ##
## images est de lui.                                 ##
########################################################
########################################################

loc=dir+'logo2.tga'
loc2=dir+'la.tga'
loc3=dir+'noz.tga'

def read_tgafile(loc):
    width=0
    height=0
    f=open(loc,'rb')
    ee=f.read(18);
    width=ord(ee[13])*256+ord(ee[12])
    height=ord(ee[15])*256+ord(ee[14])
    ee=f.read()
    f.close()
    n=0
    bitmap= Buffer(GL_BYTE, ( height, width, 4))
    for y in range(height-1,0,-1):
        for x in range(0, width):
            bitmap[y][x][2]= ord(ee[n]); n=n+1
            bitmap[y][x][1]= ord(ee[n]); n=n+1
            bitmap[y][x][0]= ord(ee[n]); n=n+1
    return bitmap,width,height

bitmap,width, height=read_tgafile(loc)
bitmap2,width2, height2=read_tgafile(loc2)
bitmap3,width3, height3=read_tgafile(loc3)

##--Les declarations--##################################
########################################################

menuy= Create(100)
ndefx = Create(20)
ndefy = Create(20)
rahmin = Create(0)
rahmax = Create(0)
rahall = Create(0)
Tog = Create(0)
Togi = Create(0)
TogN = Create(0)
Togcol1 = Create(0)
Togcol2 = Create(1)
Togcol3 = Create(0)


wsize = Buffer(GL_INT, 4) 
glGetIntegerv(GL_VIEWPORT, wsize)
Sposb= [wsize[0], wsize[1]]

Spos = [0.0, 0.0]
tpin = Create(3)
Vop  = Create(3)
Posx = 115
Posy = 13
Sisx = 300
Sisy = 300
Clig = 0
Clid = 0
fpin=(Vop.val*1.00)/100
lk=0
rk=0
uk=0
dk=0
sk=0
ini=0
Defgx=0
Defgy=0
gigamap=[]
Hypmap=[]
Valcott=[0.0,0.0,0.0]
placolR=0
placolG=0
placolB=0
Savcol=[[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[1.0,1.0,1.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0]]
Poscox=140
Poscoy=280
Sipgx=0
Sipgy=0
selcol=[1.0,1.0,1.0]
Cligcol=0
clicolch=0
v1=0
v3=0
v5=0
v6=0
sig=0
Alp=0
Alp2=0
op_vcol=1
op_vcol_type=2


##--Creation de base de donnee--########################
########################################################
def built(Hypmap):
    Defx = ndefy.val
    Defy = ndefy.val
    if Defx <= 150:
        Defgx=5
    if Defy <= 150:
        Defgy=5
    if 150 < Defx <= 250:
        Defgx=10
    if 150 < Defy <= 250:
        Defgy=10
    if Defx % Defgx != 0:
        Defx=Defx+(Defgx-(Defx % Defgx))
    if Defy % Defgy != 0:
        Defy=Defy+(Defgy-(Defy % Defgy))
    Sipx=((Sisx*1.0)/(Defx*1.0))
    Sipy=((Sisy*1.0)/(Defy*1.0))
    Numgx=(Defx/Defgx)
    if (Numgx*Defgx) != Defx:
        Numgx=Numgx+1
    Numgy=(Defy/Defgy)
    if (Numgy*Defgy) != Defy:
        Numgy=Numgy+1
    Hypmap=[]
    Sipgx=(Sipx*Defgx)
    Sipgy=(Sipy*Defgy)
    Vbgx=0
    Vbgy=0
    while Vbgx < Numgx:	
        Map=[]
        Vbx=0
        Vby=0
        while Vbx < Defgx:
            Cont=[Vbx,Vby,0.0,0.5,0.5,0.5]
            Map.append(Cont)
            while Vby < Defgy-1:
                Cont=[Vbx,Vby+1,0.0,0.5,0.5,0.5]
                Map.append(Cont)
                Vby=Vby+1
            Vby=0
            Vbx=Vbx+1
        while Vbgy < Numgy:
            Map=[]
            Vbx=0
            Vby=0
            while Vbx < Defgx:
                Cont=[Vbx,Vby,0.0,0.5,0.5,0.5]
                Map.append(Cont)
                while Vby < Defgy-1:
                    Cont=[Vbx,Vby+1,0.0,0.5,0.5,0.5]
                    Map.append(Cont)
                    Vby=Vby+1
                Vby=0
                Vbx=Vbx+1
            Cont=[Vbgx,Vbgy,Map]
            Hypmap.append(Cont)
            Vbgy=Vbgy+1
        Vbgy=0
        Vbgx=Vbgx+1
    return Sipgx,Sipgy,Sipx,Sipy,Numgx,Numgy,Defgx,Defgy,Defx,Defy,Hypmap

Sipgx,Sipgy,Sipx,Sipy,Numgx,Numgy,Defgx,Defgy,Defx,Defy,Hypmap=built(Hypmap)

def randartisanal():
    Val=time.clock()*time.clock()
    exec('Val="%s"' % Val)
    try:
        return int(Val[9:11])
    except:
        try:
            return int(Val[8:10])
        except:
            return int(Val[4:6])

def redess(Hypmap):
    if Alp==0:
        glc(0.6,0.6,0.6)
        glr(350,5,450,40)
        glc(0.6,0.6,0.6)
        glr(100,5,200,40)
    Np = 0
    while Np < len(Hypmap):
        Np2=0
        while Np2<len(Hypmap[Np][2]):
            if menuy.val == 7 or menuy.val == 9:
                glc(1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]))
            if menuy.val == 11:
                glc(Hypmap[Np][2][Np2][3],Hypmap[Np][2][Np2][4],Hypmap[Np][2][Np2][5])
                if Alp==1:
                    gla(1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]),0.5)   
            glr(Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0],Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1],Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]+Sipx,Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]+Sipy)
            Np2=Np2+1
        Np=Np+1


def tricol(placolR,placolG,placolB,PoscoyR,PoscoyG,PoscoyB):
    glc(0,0,0)
    glr(placolB-2,PoscoyB-5,placolB+2,PoscoyB-1)
    glr(placolB-2,PoscoyB+20,placolB+2,PoscoyB+16)
    glr(placolB-2,PoscoyB,placolB-1,PoscoyB+15)
    glr(placolB+1,PoscoyB,placolB+2,PoscoyB+15)
    glr(placolG-2,PoscoyG-5,placolG+2,PoscoyG-1)
    glr(placolG-2,PoscoyG+20,placolG+2,PoscoyG+16)
    glr(placolG-2,PoscoyG,placolG-1,PoscoyG+15)
    glr(placolG+1,PoscoyG,placolG+2,PoscoyG+15)
    glr(placolR-2,PoscoyR-5,placolR+2,PoscoyR-1)
    glr(placolR-2,PoscoyR+20,placolR+2,PoscoyR+16)
    glr(placolR-2,PoscoyR,placolR-1,PoscoyR+15)
    glr(placolR+1,PoscoyR,placolR+2,PoscoyR+15)

    

##--Les tooltips--######################################
##--(ce qui s'affiche quand on passe sur un bouton)--###

tooltips={}
tooltips['m1']='Vraiment ?'
tooltips['m2']='Info'
tooltips['m3']="Besoin d'aide ?"
tooltips['m4']='Remerciements'
tooltips['m5']='Comment me contacter'
tooltips['hm']='Pour sortir de ce module'

tooltips['O1']='Modeliser un terrain'
tooltips['O2']='Option du terrain'
tooltips['O3']='Creation de la base de donnee du terrain'
tooltips['O4']='Tracer le terrain'
tooltips['O5']='Recommencer le terrain'
tooltips['O6']='Saisie de la souris'
tooltips['O7']='Lissage du terrain'
tooltips['O8']='Taille du pinceau'
tooltips['O9']='Force de traie'
tooltips['OA']='Inverse pinceau'
tooltips['OB']='Inversion terrain'
tooltips['OC']='Modification terrain'
tooltips['OD']='Peindre un terrain'
tooltips['OE']='Changer la palette'
tooltips['OF']='Revenir la peinture du terrain'
tooltips['OG']='Modeliser le terrain sans Vertex Colors'
tooltips['OH']='Vertex Colors en Noir&Blanc'
tooltips['OI']='Vertex Colors automatiques'
tooltips['OJ']='Hauteur de terrain enlever'
tooltips['OK']='Hauteur de terrain a ajouter'
tooltips['OL']='Taux de Hasard de la modification'
tooltips['in']='Detection souris'

print"Blender World V0.2 sur Blender",Blender.Get('version')
print"ICI S'AFFICHERONT LES ERREURS"

#Pour aller plus vite
glc=glColor3f
gla=glColor4f
glr=glRecti


def draw(): 
    global Togcol1, Togcol2, Togcol3, op_vcol, op_vcol_type, Alp2, Alp, sig, menuym, ndefx, ndefy, Tog, tpin, Vop, Togi, ini, wsize, Defgx, Defgy, rahmin, rahmax, rahall, TogN, Poscox, PoscoyR, PoscoyG, PoscoyB, placolR, placolG, placolB, Valcott, Savcol, Poscoy, selcol, Cligcol, clicolch
  
    if menuy.val != 7 and menuy.val != 9 and menuy.val != 11 and menuy.val != 12:
        glClearColor(0, 0, 0, 0.0) 
        glDisable(GL_BLEND)
        glClear(GL_COLOR_BUFFER_BIT) 
        #glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
        glRasterPos2i(10, 400)
        glDrawPixels (width, height, GL_RGBA, GL_UNSIGNED_BYTE, bitmap)
        glRasterPos2i(50, 250)
        glDrawPixels (width2, height2, GL_RGBA, GL_UNSIGNED_BYTE, bitmap2)

        glRasterPos2i(150, 140)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        glc(1,1,1)
        glr(220,340,600,350)
        if wsize[0]>30: 
            glr(86,0,96,251)
            glc(0.6,0.6,0.6)
            glr(95,0,600,251)
        else:
            glr(87,0,96,251)
            glc(0.6,0.6,0.6)
            glr(96,0,600,251)            
        glr(220,340,600,250)

        glc(0.6,0.6,0.6)
        glr(119,140,179,141)
        glc(0.4,1.0,0.4)
        glRasterPos2d(390, 410)
        Text("V0.2")


    if menuy.val== 100:
        glc(0,0,0)
        glRasterPos2d(180, 160)
        Text("NOZ Presente BlenderWorld")
        glRasterPos2d(180, 140)
        Text("Le Modeleur de terrain pour BLENDER")
        glRasterPos2i(150, 140)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        glc(0.6,0.6,0.6)
        glr(119,140,179,141)

    


    Button("Quitter", 9, 340, 360, 80, 20, tooltips['m1'])
    Button("Info", 2, 20, 360, 80, 20, tooltips['m2'])
    Button("Aide", 3, 100, 360, 80, 20, tooltips['m3'])
    Button("Credits", 4, 180, 360, 80, 20, tooltips['m4'])
    Button("Contact", 5, 260, 360, 80, 20, tooltips['m5'])

    if menuy.val != 100 and menuy.val != 7 and menuy.val != 9 and menuy.val != 11 and menuy.val != 12: Button("Sortir", 6, 360, 10, 70, 19, tooltips['hm']) 
    Button("Modelisation", 7, 2.5, 210, 80, 20, tooltips['O1'])
    Button("Options", 8, 2.5, 315, 80, 20, tooltips['O2'])
    Button("Modifications", 22, 2.5, 245, 80, 20, tooltips['OC'])
    Button("VertexPaint", 24, 2.5, 280, 80, 20, tooltips['OD'])

    if menuy.val== 7:
        Button("Tracer", 10, 2.5, 10, 80, 20, tooltips['O4'])
        Button("Effacer", 11, 2.5, 45, 80, 20, tooltips['O5'])
        tpin= Number("Taille : ", 100, 2.5, 80, 80, 20, tpin.val, 1, 10, tooltips['O8'])
        Vop= Number("Force", 1, 2.5, 115, 80, 20, Vop.val, 1, 20, tooltips['O9'])
        Togi=Toggle("Inverse", 14, 2.5, 150, 80, 20,Togi.val, tooltips['OA'])
        glc(0.9,0.9,0.9)
        glr(10,185,70,190)

    if menuy.val== 11 or menuy.val ==10:
        Button("Effacer", 11, 2.5, 10, 80, 20, tooltips['O5'])
        tpin= Number("Taille : ", 100, 2.5, 150, 80, 20, tpin.val, 1, 10, tooltips['O8'])
        Vop= Number("Force", 1, 2.5, 115, 80, 20, Vop.val, 1, 20, tooltips['O9'])
        if menuy.val ==11:
             Button("Couleurs", 25, 2.5, 80, 80, 20, tooltips['OE'])
        else:
             Button("Painting", 24, 2.5, 80, 80, 20, tooltips['OF']) 
        glc(1,1,1)
        glr(10,185,71,190)
        glc(0,0,0)
        glr(1,40,85,70)
        glc(selcol[0],selcol[1],selcol[2])
        glr(10,45,71,65)


 
    glc(0.0,0.0,0.3)
    if menuy.val ==8: 
        glRasterPos2f(230, 270) 
        Text("Options:")
        glRasterPos2f(120, 230) 
        Text("Definition du terrain: ")
        glRasterPos2f(120, 80) 
        Text("Vertex Colors:")

        ndefy= Number("X : ", 100, 300, 200, 80, 19, ndefy.val, 10, 250)
        ndefy= Number("Y : ", 100, 200, 200, 80, 19, ndefy.val, 10, 250)
        Button("Creation", 13, 110, 10, 80, 20, tooltips['O3'])
        Tog=Toggle("Lissage", 100, 300, 100, 80, 20,Tog.val, tooltips['O7'])
        Button("Saisis", 20, 300, 150, 80, 20, tooltips['O6'])
        Togcol1=Toggle("Sans", 35, 120, 50, 80, 20,Togcol1.val, tooltips['OG'])
        Togcol2=Toggle("N/B", 36, 210, 50, 80, 20,Togcol2.val, tooltips['OH'])  
        Togcol3=Toggle("Auto", 37, 300, 50, 80, 20,Togcol3.val, tooltips['OI'])  
        glRasterPos2f(120, 180) 
        Text("Saisie des informations de la souris:") 
        glRasterPos2f(120, 130) 
        Text("Lissage du terrain:")  

    if menuy.val ==9: 
        glc(0.9,0.9,0.9)
        glr(10,185,70,190)
        TogN=Toggle("Negatif", 21, 2.5, 150, 80, 20, TogN.val, tooltips['OB'])
        rahmin= Number("H en + : ", 100, 2.5, 115, 80, 20, rahmin.val, 0, 100, tooltips['OJ'])
        rahmax= Number("H en - : ", 100, 2.5, 80, 80, 20, rahmax.val, 0, 100, tooltips['OK'])
        rahall= Number("Hasard : ", 100, 2.5, 45, 80, 20, rahall.val, 0, 100, tooltips['OL'])
        Button("Modifier", 23, 2.5, 10, 80, 20, tooltips['O3'])

    if menuy.val ==12 :
        glc(0.0,0.0,0.0)
        glr(Poscox+28,Poscoy-138,Poscox+232,Poscoy-222) 
        glc(0.9,0.9,0.9)
        glr(Poscox+30,Poscoy-140,Poscox+230,Poscoy-220) 
        Np2=0
        for i in Savcol:
            if Np2 < 5:
                glc(Savcol[Np2][0],Savcol[Np2][1],Savcol[Np2][2])
                glr(Poscox+(Np2*40)+40,Poscoy-150,Poscox+20+(Np2*40)+40,Poscoy-170)
            else:
                glc(Savcol[Np2][0],Savcol[Np2][1],Savcol[Np2][2])
                glr(Poscox+((Np2-5)*40)+40,Poscoy-190,Poscox+20+((Np2-5)*40)+40,Poscoy-210)               
            Np2=Np2+1

    if menuy.val ==10 :
        PoscoyR=Poscoy-80
        PoscoyG=PoscoyR+40
        PoscoyB=PoscoyR+80
        Np2=0
        while Np2 < 3:
            Np=0
            while  Np < 255:
                Valco=((Np*1.00)/255)
                if Np2==0:
                    glc(Valco,0.0,0.0)
                    glr (Poscox + Np,PoscoyR,Poscox+Np+1,PoscoyR+15)
                elif Np2==1:
                    glc(0.0,Valco,0.0)
                    glr (Poscox + Np,PoscoyG,Poscox+Np+1,PoscoyG+15)
                else:
                    glc(0.0,0.0,Valco)
                    glr (Poscox + Np,PoscoyB,Poscox+Np+1,PoscoyB+15)
                Np=Np+1
            Np2=Np2+1

        glc(0,0,0)
        glr(Poscox+49,Poscoy-170,Poscox+51,Poscoy-190) 
        glr(Poscox+89,Poscoy-170,Poscox+91,Poscoy-190)              
        glr(Poscox+209,Poscoy-170,Poscox+211,Poscoy-190) 
        glr(Poscox+89,Poscoy-159,Poscox+211,Poscoy-161)
        glr(Poscox+89,Poscoy-201,Poscox+211,Poscoy-199)
        glr(Poscox+129,Poscoy-130,Poscox+131,Poscoy-150) 
        glc(0.0,0.0,0.0)
        glr(Poscox+28,Poscoy-138,Poscox+232,Poscoy-222) 
        glc(0.9,0.9,0.9)
        glr(Poscox+30,Poscoy-140,Poscox+230,Poscoy-220) 

        Np2=0
        for i in Savcol:
            if Np2 < 5:
                glc(Savcol[Np2][0],Savcol[Np2][1],Savcol[Np2][2])
                glr(Poscox+(Np2*40)+40,Poscoy-150,Poscox+20+(Np2*40)+40,Poscoy-170)
            else:
                glc(Savcol[Np2][0],Savcol[Np2][1],Savcol[Np2][2])
                glr(Poscox+((Np2-5)*40)+40,Poscoy-190,Poscox+20+((Np2-5)*40)+40,Poscoy-210)               
            Np2=Np2+1                               
        tricol(placolR,placolG,placolB,PoscoyR,PoscoyG,PoscoyB)
        glc(Valcott[0],Valcott[1],Valcott[2])
        glr(Poscox+110,Poscoy-100,Poscox+150,Poscoy-130)



    if menuy.val ==2: 
        glRasterPos2f(230, 270) 
        Text("Infos:")
        glRasterPos2f(120, 230) 
        Text("Dans les prochaines versions de BlenderWorld")
        glRasterPos2f(120, 210) 
        Text("sera integre :")
        glRasterPos2f(120, 190) 
        Text("Modelisations :")
        glRasterPos2f(120, 170) 
        Text("--> Import/export fomat image")
        glRasterPos2f(120, 150) 
        Text("--> Optimisation graphique (300*300 TR)")
        glRasterPos2f(120, 130) 
        Text("--> Pinceaux speciaux")
        glRasterPos2f(120, 110) 

    if menuy.val ==3: 
        glRasterPos2f(230, 270) 
        Text("Aide:")
        glRasterPos2f(120, 230) 
        Text("")
        glRasterPos2f(120, 210) 
        Text("")
        glRasterPos2f(120, 180) 
        Text("")
        glRasterPos2f(120, 160) 
        Text("")
        glRasterPos2f(120, 140) 
        Text("")
        glRasterPos2f(120, 120) 
        Text("")
        glRasterPos2f(120, 90) 
        Text("")
        glRasterPos2f(120, 70) 
        Text("")
    if menuy.val ==4:
        glRasterPos2f(230, 270) 
        Text("Remerciments:")
        glRasterPos2f(120, 230) 
        Text("")
        glRasterPos2f(120, 210) 
        Text("")
        glRasterPos2f(120, 180) 
        Text("")
        glRasterPos2f(120, 160) 
        Text("")
        glRasterPos2f(120, 130) 
        Text("")
        glRasterPos2f(120, 110) 
        Text("")
    if menuy.val ==5:
        glc(0.6,0.1,0.1)
        glRasterPos2f(230, 270) 
        Text("Contact:")
        glc(1,1,1)
        glRasterPos2f(175, 230) 
        Text("Si vous voulez me contacter:")
        glRasterPos2f(204, 200) 
        Text("noz@4devstudio.com")
        glRasterPos2i(250, 120)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        glc(0.6,0.6,0.6)
        glr(241,120,280,121)




def event(evt, val):
    global op_vcol, op_vcol_type, Alp2, Alp, sig, Map, Defx, Defy, Posx, Posy, Sisx, Sisy, Spos, Sipx, Sipy, menuy, Clig, Clid, tpin, Vop, mdef, fpin, lk, rk, dk, uk, sk, Togi, Sposb, wsize, Tog,v1,v2,v3,v4,v5,v6, gigamap, TogN, rahmax, rahmin, rahall, Poscox, Poscoy, PoscoyR, PoscoyG, PoscoyB, placolR, placolG, placolB, Valcott, Savcol, selcol, Cligcol, clicolch
    if (evt== QKEY): Exit()
    dX = 0
    dY = 0
    Np = 0
    if Togi.val==1:
        fpin=(Vop.val*(-1.00))/100
    else:
        fpin=(Vop.val*1.00)/100


    if evt == MOUSEX:
        dX = val - Spos[0]
        Spos[0] = val



    if evt == MOUSEY:
        dY = val - Spos[1]
        Spos[1] = val 

    if (evt == LEFTMOUSE and Spos[0] - Sposb[0] > Posx and Spos[0] - Sposb[0] < Posx+Sisx and Spos[1] - Sposb[1] > Posy and Spos[1] - Sposb[1] < Posy+Sisy):
        if menuy.val == 7:
            if Clig==0:
                Clig=1
                v1=((tpin.val-1)*Sipx)
                v3=Sipx+((tpin.val-1)*Sipx)
                v5=((tpin.val-1)*Sipy)
                v6=Sipy+((tpin.val-1)*Sipy)
            else:
                Clig=0
        if menuy.val == 11:
            if Cligcol==0:
                if sig==1: 
                    sig=0
                    Cligcol=0
                else:
                    Cligcol=1
                v1=((tpin.val-1)*Sipx)
                v3=Sipx+((tpin.val-1)*Sipx)
                v5=((tpin.val-1)*Sipy)
                v6=Sipy+((tpin.val-1)*Sipy)
            else:
                if sig==1: 
                    sig=0
                    Cligcol=1
                else:
                    Cligcol=0
        if Alp==1:
            Alp=0
            Alp2=0
            redess(Hypmap)
            Draw()

    if Alp==1 and menuy.val != 11:
            Alp=0
            Alp2=0
            Draw()
            
    if  (evt == LEFTMOUSE and menuy.val == 11):
        if (Spos[0] - Sposb[0] > Posx and Spos[0] - Sposb[0] < Posx+Sisx and Spos[1] - Sposb[1] > Posy and Spos[1] - Sposb[1] < Posy+Sisy):
            if clicolch==1:
                clicolch=0
            else:
                clicolch=1
        if 10 < Spos[0] - Sposb[0] and 71 > Spos[0] - Sposb[0] and 45 < Spos[1] - Sposb[1] and 65 > Spos[1] - Sposb[1]:
            menuy.val = 12

    if  (evt == LEFTMOUSE):
        if menuy.val == 10:
            if Poscox < Spos[0] - Sposb[0] and Poscox + 255 > Spos[0] - Sposb[0] and PoscoyR < Spos[1] - Sposb[1] and PoscoyR + 15 > Spos[1] - Sposb[1]:
                Valcott[0]=(((Spos[0] - Sposb[0])-(Poscox*1.00))/255)
                placolR=(Spos[0] - Sposb[0])
            if Poscox < Spos[0] - Sposb[0] and Poscox + 255 > Spos[0] - Sposb[0] and PoscoyG < Spos[1] - Sposb[1] and PoscoyG + 15 > Spos[1] - Sposb[1]:
                Valcott[1]=(((Spos[0] - Sposb[0])-(Poscox*1.00))/255)
                placolG=(Spos[0] - Sposb[0])
            if Poscox < Spos[0] - Sposb[0] and Poscox + 255 > Spos[0] - Sposb[0] and PoscoyB < Spos[1] - Sposb[1] and PoscoyB + 15 > Spos[1] - Sposb[1]:
                Valcott[2]=(((Spos[0] - Sposb[0])-(Poscox*1.00))/255)
                placolB=(Spos[0] - Sposb[0]) 
            tricol(placolR,placolG,placolB,PoscoyR,PoscoyG,PoscoyB)
        if menuy.val == 10 or menuy.val == 12:
            if Poscox+40 < Spos[0] - Sposb[0] and Poscox + 60 > Spos[0] - Sposb[0] and Poscoy-170 < Spos[1] - Sposb[1] and Poscoy-150> Spos[1] - Sposb[1]:
                if menuy.val == 12:
                    selcol=Savcol[0]
                    menuy.val = 11 
            if Poscox+80 < Spos[0] - Sposb[0] and Poscox + 100 > Spos[0] - Sposb[0] and Poscoy-170 < Spos[1] - Sposb[1] and Poscoy-150> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[1]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[1]
                    menuy.val = 11  
            if Poscox+120 < Spos[0] - Sposb[0] and Poscox + 140 > Spos[0] - Sposb[0] and Poscoy-170 < Spos[1] - Sposb[1] and Poscoy-150> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[2]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[2]
                    menuy.val = 11  
            if Poscox+160 < Spos[0] - Sposb[0] and Poscox + 180 > Spos[0] - Sposb[0] and Poscoy-170 < Spos[1] - Sposb[1] and Poscoy-150> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[3]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[3]
                    menuy.val = 11  
            if Poscox+200 < Spos[0] - Sposb[0] and Poscox + 220 > Spos[0] - Sposb[0] and Poscoy-170 < Spos[1] - Sposb[1] and Poscoy-150> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[4]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[4]
                    menuy.val = 11
            if Poscox+40 < Spos[0] - Sposb[0] and Poscox + 60 > Spos[0] - Sposb[0] and Poscoy-210 < Spos[1] - Sposb[1] and Poscoy-190> Spos[1] - Sposb[1]:
                if menuy.val == 12:
                    selcol=Savcol[5]
                    menuy.val = 11
            if Poscox+80 < Spos[0] - Sposb[0] and Poscox + 100 > Spos[0] - Sposb[0] and Poscoy-210 < Spos[1] - Sposb[1] and Poscoy-190> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[6]=%s' % Valcott)
                if menuy.val == 12:
                    selcol=Savcol[6]
                    menuy.val = 11   
            if Poscox+120 < Spos[0] - Sposb[0] and Poscox + 140 > Spos[0] - Sposb[0] and Poscoy-210 < Spos[1] - Sposb[1] and Poscoy-190> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[7]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[7]
                    menuy.val = 11    
            if Poscox+160 < Spos[0] - Sposb[0] and Poscox + 180 > Spos[0] - Sposb[0] and Poscoy-210 < Spos[1] - Sposb[1] and Poscoy-190> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[8]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[8]
                    menuy.val = 11  
            if Poscox+200 < Spos[0] - Sposb[0] and Poscox + 220 > Spos[0] - Sposb[0] and Poscoy-210 < Spos[1] - Sposb[1] and Poscoy-190> Spos[1] - Sposb[1]:
                if menuy.val == 10: 
                   exec('Savcol[9]=%s' % Valcott) 
                if menuy.val == 12:
                    selcol=Savcol[9]
                    menuy.val = 11
            if menuy.val == 11:
                redess(Hypmap)
                sig=1
        Draw()                                   


 
    if (evt == RIGHTMOUSE and Spos[0] - Sposb[0] > Posx and Spos[0] - Sposb[0] < Posx+Sisx and Spos[1] - Sposb[1] > Posy and Spos[1] - Sposb[1] < Posy+Sisy and menuy.val == 7):
        if Clid==0:
            fpin=fpin*(-1)
            if Togi.val==1:
                Togi.val=0
            else:
                Togi.val=1
            Clid=1
        else:
            Clid=0
        Blender.Redraw()
    if evt== XKEY:
        Np = 0
        while Np < len(Hypmap):
            Np2=0
            while Np2< len(Hypmap[Np][2]):
                if menuy.val == 7 or menuy.val == 9:
                    Hypmap[Np][2][Np2][2]=0.0
                if menuy.val == 11:
                    Hypmap[Np][2][Np2][3]=1.0
                    Hypmap[Np][2][Np2][4]=0.0
                    Hypmap[Np][2][Np2][5]=1.0
                Np2=Np2+1
            Np=Np+1
        if menuy.val == 7 or menuy.val == 9:
            glc(1.0,1.0,1.0)
        if menuy.val == 11: 
            glc(1.0,0.0,1.0)   
        glr(Posx,Posy,Posx+Sisx,Posy+Sisy)

        Draw()


    if evt== LEFTARROWKEY:
        if lk==0 and Vop.val>=2:
            Vop.val=Vop.val-1
            lk=1
        else:
            lk=0
        Draw()
    if evt== RIGHTARROWKEY and Vop.val<=19:
        if rk==0:
            Vop.val=Vop.val+1
            rk=1
        else:
            rk=0
        Draw()
    if evt== UPARROWKEY and tpin.val<=9:
        if uk==0:
            tpin.val=tpin.val+1
            uk=1
        else:
            uk=0
        ini=1
        Draw()
    if evt== DOWNARROWKEY and tpin.val>=2:
        if dk==0:
            tpin.val=tpin.val-1
            dk=1
        else:
            dk=0
        Draw()
    if evt== RKEY:
        menuy.val=100
        wsize = Buffer(GL_INT, 4) 
        glGetIntegerv(GL_VIEWPORT, wsize)
        Sposb= [wsize[0], wsize[1]]
        Draw()

    if evt== AKEY:
        if menuy.val==11:
            if Alp2==0:
                Alp=1
                glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
                glEnable(GL_BLEND)
                redess(Hypmap)
                Alp2=1
        Draw()

    if evt== SPACEKEY:
        if sk==0:
            bevent(10)
            sk=1
        else:
            sk=0
        Draw()
    if (evt ==MIDDLEMOUSE or evt== TKEY):
        Cligcol=0
        Clig=0
        #Draw()

    if Clig==1:
        Np=0
        while  Np < len(Hypmap):
            if (Posx+Sipgx*Hypmap[Np][0]-v1 <= Spos[0] - Sposb[0] <= Posx+Sipgx*Hypmap[Np][0]+Sipgx+v3 and Posy+Sipgy*Hypmap[Np][1]-v5 <=  Spos[1] - Sposb[1] <= Posy+Sipgy*Hypmap[Np][1]+Sipgy+v6):
                Np2=0
                while  Np2 < len(Hypmap[Np][2]):
                    if (Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]-v1 <= Spos[0] - Sposb[0] <= Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]+v3 and Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]-v5 <=  Spos[1] - Sposb[1] <= Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]+v6):
                        Hypmap[Np][2][Np2][2]=Hypmap[Np][2][Np2][2]+fpin
                        if 0 > Hypmap[Np][2][Np2][2]:
                            Hypmap[Np][2][Np2][2]=0
                        if 1 < Hypmap[Np][2][Np2][2]:
                            Hypmap[Np][2][Np2][2]=1
                        glc(1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]),1-(Hypmap[Np][2][Np2][2]))
                        glr(Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0],Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1],Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]+Sipx,Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]+Sipy)
                    Np2=Np2+1
            Np=Np+1
        Redraw()

    if Cligcol==1:
        Np=0
        while  Np < len(Hypmap):
            if (Posx+Sipgx*Hypmap[Np][0]-v1 <= Spos[0] - Sposb[0] <= Posx+Sipgx*Hypmap[Np][0]+Sipgx+v3 and Posy+Sipgy*Hypmap[Np][1]-v5 <=  Spos[1] - Sposb[1] <= Posy+Sipgy*Hypmap[Np][1]+Sipgy+v6):
                Np2=0
                while  Np2 < len(Hypmap[Np][2]):
                    if (Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]-v1 <= Spos[0] - Sposb[0] <= Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]+v3 and Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]-v5 <=  Spos[1] - Sposb[1] <= Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]+v6):

                        if Hypmap[Np][2][Np2][3]>selcol[0]:
                            Hypmap[Np][2][Np2][3]=Hypmap[Np][2][Np2][3]-fpin
                        elif Hypmap[Np][2][Np2][3]==selcol[0]:
                            Hypmap[Np][2][Np2][3]=Hypmap[Np][2][Np2][3]
                        else:
                            Hypmap[Np][2][Np2][3]=Hypmap[Np][2][Np2][3]+fpin

                        if Hypmap[Np][2][Np2][4]>selcol[1]:
                            Hypmap[Np][2][Np2][4]=Hypmap[Np][2][Np2][4]-fpin
                        elif Hypmap[Np][2][Np2][4]==selcol[1]:
                            Hypmap[Np][2][Np2][4]=Hypmap[Np][2][Np2][4]
                        else:
                            Hypmap[Np][2][Np2][4]=Hypmap[Np][2][Np2][4]+fpin

                        if Hypmap[Np][2][Np2][5]>selcol[2]:
                            Hypmap[Np][2][Np2][5]=Hypmap[Np][2][Np2][5]-fpin
                        elif Hypmap[Np][2][Np2][5]==selcol[2]:
                            Hypmap[Np][2][Np2][5]=Hypmap[Np][2][Np2][5]
                        else:
                            Hypmap[Np][2][Np2][5]=Hypmap[Np][2][Np2][5]+fpin


                        if 0 > Hypmap[Np][2][Np2][3]:
                            Hypmap[Np][2][Np2][3]=0
                        if 1 < Hypmap[Np][2][Np2][3]:
                            Hypmap[Np][2][Np2][3]=1
                        if 0 > Hypmap[Np][2][Np2][4]:
                            Hypmap[Np][2][Np2][4]=0
                        if 1 < Hypmap[Np][2][Np2][4]:
                            Hypmap[Np][2][Np2][4]=1
                        if 0 > Hypmap[Np][2][Np2][5]:
                            Hypmap[Np][2][Np2][5]=0
                        if 1 < Hypmap[Np][2][Np2][5]:
                            Hypmap[Np][2][Np2][5]=1
                        glc(Hypmap[Np][2][Np2][3],Hypmap[Np][2][Np2][4],Hypmap[Np][2][Np2][5])
                        glr(Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0],Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1],Posx+Sipgx*Hypmap[Np][0]+Sipx*Hypmap[Np][2][Np2][0]+Sipx,Posy+Sipgy*Hypmap[Np][1]+Sipy*Hypmap[Np][2][Np2][1]+Sipy)
                    Np2=Np2+1
            Np=Np+1
        Redraw()


def bevent(evt):
    global Togcol1, Togcol2, Togcol3, op_vcol, op_vcol_type, Map, Defx, Defy, Posx, Posy, Sisx, Sisy, Spos, Sipx, Sipy, menuy, Clig, Clid, tpin, Vop, mdef, fpin, ndefy, ndefx, Togi, ini, Sposb, Hypmap, Numgx, Numgy, Defgx, Defgy, Sipgy, Sipgx, TogN, rahmax, rahmin, rahall
    if (evt== 20):
        wsize = Buffer(GL_INT, 4) 
        glGetIntegerv(GL_VIEWPORT, wsize)
        Sposb= [wsize[0], wsize[1]]
        Draw()
    if (evt== 21):
        Np = 0
        while Np < len(Hypmap):
            Np2=0
            while Np2< len(Hypmap[Np][2]):
                Hypmap[Np][2][Np2][2]=1-Hypmap[Np][2][Np2][2]
                Np2=Np2+1
            Np=Np+1
        Draw()
    if (evt== 22):
        menuy.val=9
        redess(Hypmap)
        Draw()
    if (evt== 24):
        menuy.val=11
        redess(Hypmap)
        Draw()
    if (evt== 25):
        menuy.val=10
        Draw()
    if (evt== 23):
        Np = 0
        while Np < len(Hypmap):
            Np2=0
            while Np2< len(Hypmap[Np][2]):
                if rahall.val != 0:
                     tpv=((100-((randartisanal()*1.00)/100)*(rahall.val*1.00)))/100
                else:
                     tpv=0
                Hypmap[Np][2][Np2][2]=Hypmap[Np][2][Np2][2]+((((rahmin.val-rahmax.val)*1.00)/100)*tpv)
                if 0 > Hypmap[Np][2][Np2][2]:
                    Hypmap[Np][2][Np2][2]=0
                if 1 < Hypmap[Np][2][Np2][2]:
                    Hypmap[Np][2][Np2][2]=1
                Np2=Np2+1
            Np=Np+1
        redess(Hypmap)
        Draw()
    if (evt== 14):
        fpin=fpin*(-1)
        Draw()
 
    if (evt== 13):
        Sipgx,Sipgy,Sipx,Sipy,Numgx,Numgy,Defgx,Defgy,Defx,Defy,Hypmap=built(Hypmap)
        Draw()


    if (evt== 1):
        fpin=(Vop.val*1.00)/100
        Draw()
    if (evt== 8):
        menuy.val=8
        Draw()
#Tout effacer
    if (evt== 11):
        Np = 0
        while Np < len(Hypmap):
            Np2=0
            while Np2< len(Hypmap[Np][2]):
                if menuy.val == 7 or menuy.val == 9:
                    Hypmap[Np][2][Np2][2]=0.0
                if menuy.val == 11:
                    Hypmap[Np][2][Np2][3]=1.0
                    Hypmap[Np][2][Np2][4]=0.0
                    Hypmap[Np][2][Np2][5]=1.0
                Np2=Np2+1
            Np=Np+1
        if menuy.val == 7 or menuy.val == 9:
            glc(1.0,1.0,1.0)
        if menuy.val == 11: 
            glc(1.0,0.0,1.0)       
        glr(Posx,Posy,Posx+Sisx,Posy+Sisy)
        Draw()
#Quitter
    if (evt== 9):
        sys.stdout.flush()
        Exit()
#Redessine
    if (evt== 100):
        Draw()

    if (evt== 35):
        if Togcol1.val==1:
            Togcol2.val=0
            Togcol3.val=0
            Togcol1.val=1
            op_vcol=0
            op_vcol_type=1
        else:
            op_vcol=1
            op_vcol_type=1
        Draw()
    if (evt== 36):
        if Togcol2.val==1:
            Togcol1.val=0
            Togcol3.val=0
            Togcol2.val=1
            op_vcol=1
            op_vcol_type=2
        else:
            op_vcol=1
            op_vcol_type=1
        Draw()
    if (evt== 37):
        if Togcol3.val==1:
            Togcol1.val=0
            Togcol3.val=1
            Togcol2.val=0
            op_vcol=1
            op_vcol_type=3
        else:
            op_vcol=1
            op_vcol_type=1
        Draw()
#Info
    if (evt== 2):
        menuy.val=2
        Draw()
#Aide
    if (evt== 3):
        menuy.val=3
        Draw()
#Credits
    if (evt== 4):
        menuy.val=4
        Draw()
#Contact
    if (evt== 5):
        menuy.val=5
        Draw()
#Sortir
    if (evt== 6):
        menuy.val = 100
        Draw()
#Terrain
    if (evt== 7):
        menuy.val = 7
        redess(Hypmap)
        Draw()
#Tracer
    if (evt== 10):
        facemodes=Blender.NMesh.FaceModes
        gigamap=[]
        Vbgx=0
        while Vbgx <= Numgx-1:
            Vbx=0
            while Vbx < Defgx:
                Vbgy=0
                while Vbgy <= Numgy-1:
                    Vby=0
                    while Vby < Defgy:
                        Cont=[Vbx+(Defgx*Vbgx),Vby+(Defgy*Vbgy),Hypmap[Vbgy+(Vbgx*Numgx)][2][Vby+(Vbx*Defgx)][2],Hypmap[Vbgy+(Vbgx*Numgx)][2][Vby+(Vbx*Defgx)][3],Hypmap[Vbgy+(Vbgx*Numgx)][2][Vby+(Vbx*Defgx)][4],Hypmap[Vbgy+(Vbgx*Numgx)][2][Vby+(Vbx*Defgx)][5]]      
                        gigamap.append(Cont)
                        Vby=Vby+1
                    Vbgy=Vbgy+1
                Vbx=Vbx+1
            Vbgx=Vbgx+1
        me=NMesh.GetRaw()
        try:
            me.has_col=op_vcol
        except:
            pass
        Np = 0
        while Np < len(gigamap):
            v=NMesh.Vert(gigamap[Np][0]-(Defx/2)+0.5,gigamap[Np][1]-(Defy/2)+0.5,(gigamap[Np][2]*(Defy/5)))
            me.verts.append(v)
            Np=Np+1
        Np = 0
        while Np < len(gigamap)-((Defgx*Numgx)-1): # (int(Defgx*Numgx)*int(Defgy*Numgy))+int(Defgx*Numgx):
            if ((Np+1) % (int(Defgx*Numgx)))==0 and Np!=0:
                pass
            else:
                try:
                    f=NMesh.Face()
                    if Tog.val==1: f.smooth=1
                    f.v.append(me.verts[Np])
                    f.v.append(me.verts[Np+1])
                    f.v.append(me.verts[Defgx*Numgx+Np+1])
                    f.v.append(me.verts[Defgx*Numgx+Np])
                    if op_vcol==1:
                        if op_vcol_type==1:
                            r1 = (gigamap[Np][3])*255
                            v1 = (gigamap[Np][4])*255
                            b1 = (gigamap[Np][5])*255
                            r2 = (gigamap[Np+1][3])*255
                            v2 = (gigamap[Np+1][4])*255
                            b2 = (gigamap[Np+1][5])*255
                            r3 = (gigamap[Np+(Defgx*Numgx)+1][3])*255
                            v3 = (gigamap[Np+(Defgx*Numgx)+1][4])*255
                            b3 = (gigamap[Np+(Defgx*Numgx)+1][5])*255
                            r4 = (gigamap[Np+(Defgx*Numgx)][3])*255
                            v4 = (gigamap[Np+(Defgx*Numgx)][4])*255
                            b4 = (gigamap[Np+(Defgx*Numgx)][5])*255
                        if op_vcol_type==2:
                            r1 = (gigamap[Np][2])*255
                            v1 = (gigamap[Np][2])*255
                            b1 = (gigamap[Np][2])*255
                            r2 = (gigamap[Np+1][2])*255
                            v2 = (gigamap[Np+1][2])*255
                            b2 = (gigamap[Np+1][2])*255
                            r3 = (gigamap[Np+(Defgx*Numgx)+1][2])*255
                            v3 = (gigamap[Np+(Defgx*Numgx)+1][2])*255
                            b3 = (gigamap[Np+(Defgx*Numgx)+1][2])*255
                            r4 = (gigamap[Np+(Defgx*Numgx)][2])*255
                            v4 = (gigamap[Np+(Defgx*Numgx)][2])*255
                            b4 = (gigamap[Np+(Defgx*Numgx)][2])*255
                        if op_vcol_type==3:
                            if (gigamap[Np][2]) <= 0.2:
                                r1 = 255
                                v1 = (gigamap[Np][2]*5)*255
                                b1 = 0
                            if (gigamap[Np+1][2]) <= 0.2:
                                r2 = 255
                                v2 = (gigamap[Np+1][2]*5)*255
                                b2 = 0
                            if (gigamap[Np+(Defgx*Numgx)+1][2]) <= 0.2:
                                r3 = 255
                                v3 = (gigamap[Np+(Defgx*Numgx)+1][2]*5)*255
                                b3 = 0
                            if (gigamap[Np+(Defgx*Numgx)][2]) <= 0.2:
                                r4 = 255
                                v4 = (gigamap[Np+(Defgx*Numgx)][2]*5)*255
                                b4 = 0

                            if 0.2 < (gigamap[Np][2]) <= 0.4:
                                r1 = 255-((gigamap[Np][2]-0.2)*5)*255
                                v1 = 255
                                b1 = 0
                            if 0.2 < (gigamap[Np+1][2]) <= 0.4:
                                r2 = 255-((gigamap[Np+1][2]-0.2)*5)*255
                                v2 = 255
                                b2 = 0
                            if 0.2 < (gigamap[Np+(Defgx*Numgx)+1][2]) <= 0.4:
                                r3 = 255-((gigamap[Np+(Defgx*Numgx)+1][2]-0.2)*5)*255
                                v3 = 255
                                b3 = 0
                            if 0.2 < (gigamap[Np+(Defgx*Numgx)][2]) <= 0.4:
                                r4 = 255-((gigamap[Np+(Defgx*Numgx)][2]-0.2)*5)*255
                                v4 = 255
                                b4 = 0

                            if 0.4 < (gigamap[Np][2]) <= 0.6:
                                r1 = 0
                                v1 = 255
                                b1 = ((gigamap[Np][2]-0.4)*5)*255
                            if 0.4 < (gigamap[Np+1][2]) <= 0.6:
                                r2 = 0
                                v2 = 255
                                b2 = ((gigamap[Np+1][2]-0.4)*5)*255
                            if 0.4 < (gigamap[Np+(Defgx*Numgx)+1][2]) <= 0.6:
                                r3 = 0
                                v3 = 255
                                b3 = ((gigamap[Np+(Defgx*Numgx)+1][2]-0.4)*5)*255
                            if 0.4 < (gigamap[Np+(Defgx*Numgx)][2]) <= 0.6:
                                r4 = 0
                                v4 = 255
                                b4 = ((gigamap[Np+(Defgx*Numgx)][2]-0.4)*5)*255

                            if 0.6 < (gigamap[Np][2]) <= 0.8:
                                r1 = 0
                                v1 = 255-((gigamap[Np][2]-0.6)*5)*255
                                b1 = 255
                            if 0.6 < (gigamap[Np+1][2]) <= 0.8:
                                r2 = 0
                                v2 = 255-((gigamap[Np+1][2]-0.6)*5)*255
                                b2 = 255
                            if 0.6 < (gigamap[Np+(Defgx*Numgx)+1][2]) <= 0.8:
                                r3 = 0
                                v3 = 255-((gigamap[Np+(Defgx*Numgx)+1][2]-0.6)*5)*255
                                b3 = 255
                            if 0.6 < (gigamap[Np+(Defgx*Numgx)][2]) <= 0.8:
                                r4 = 0
                                v4 = 255-((gigamap[Np+(Defgx*Numgx)][2]-0.6)*5)*255
                                b4 = 255

                            if 0.8 < (gigamap[Np][2]):
                                r1 = ((gigamap[Np][2]-0.8)*5)*255
                                v1 = 0
                                b1 = 255
                            if 0.8 < (gigamap[Np+1][2]):
                                r2 = ((gigamap[Np+1][2]-0.8)*5)*255
                                v2 = 0
                                b2 = 255
                            if 0.8 < (gigamap[Np+(Defgx*Numgx)+1][2]):
                                r3 = ((gigamap[Np+(Defgx*Numgx)+1][2]-0.8)*5)*255
                                v3 = 0
                                b3 = 255
                            if 0.8 < (gigamap[Np+(Defgx*Numgx)][2]):
                                r4 = ((gigamap[Np+(Defgx*Numgx)][2]-0.8)*5)*255
                                v4 = 0
                                b4 = 255
                    
                        a = 0
                        f.col.append(NMesh.Col(r1, v1, b1, a))
                        f.col.append(NMesh.Col(r2, v2, b2, a))
                        f.col.append(NMesh.Col(r3, v3, b3, a))
                        f.col.append(NMesh.Col(r4, v4, b4, a))
                        f.uv = [ (0,0), (0,1), (1,1), (1,0) ]
                        f.mode = facemodes['SHAREDCOL']
                        f.mode = facemodes['TWOSIDE']
                    me.faces.append(f)
                except:
                    NMesh.PutRaw(me,"Terrain",1)
                    Blender.Redraw()
            Np=Np+1                      
        Blender.Redraw() 


Register(draw, event, bevent) 
#sys.stdout.flush()Blender.Redraw() 
 